/* -*- c -*- */
/* Copyright  2005 tedemo <tedemo@free.fr> */

function list_rows(table) {
  var rows, result, i;

  rows = table.getElementsByTagName ('tr');
  result = new Array ;
  
  for (i = 0; i < rows.length; i++) 
    if (list_contain (table, rows[i]))
      result.push (rows[i]);

  return result;
}

function list_contain (table, row) {
  if (row && row.className) 
    return row.className.match ('list_' + table.id);    
}

function list_row_index(rows, row) {
  var i;
  
  for (i = 0; i < rows.length; i++) 
    if (rows[i] == row)
      return i;

  return 0;
}


function list_row_select (row) {
  var inputs, i;

  if (row == null)
    return;

  if (!row.className.match (/selected/)) {
    row.className = row.className + ' selected';

    inputs = row.getElementsByTagName ('input');

    for (i = 0; i < inputs.length; i++) 
      if (inputs[i].type.match (/^checkbox/i)) {
	inputs[i].checked = true;
	break;
      }
  }
}

function list_row_deselect (row) {
  var inputs, i;

  if (row == null)
    return;

  row.className = row.className.replace (/ *selected/, '');

  inputs = row.getElementsByTagName ('input');
  
  for (i = 0; i < inputs.length; i++) 
    if (inputs[i].type.match (/^checkbox/i)) {
      inputs[i].checked = false;
      break;
    }
}

function list_row_toggle_selected (row) {
  if (row == null)
    return;

  if (row.className.match (/selected/)) 
    list_row_deselect (row);
  else
    list_row_select (row);
  
}

function list_deselect_all (table, rows) {
  var i;

  for (i = 0; i < rows.length; i++) 
    list_row_deselect (rows[i]);
}

function list_row_onmousedown(e) {
  var rows, row, table, anchor, idx;

  if (!e) e = window.event;
  if (!e) return true;
  
  row = e.target;
  if (!row) row = e.srcElement;
  if (!row) return true;

  if (row.nodeName.match (/^(a|img|input)$/i))
    return true;

  while (!row.nodeName.match (/^tr$/i)) {
    row = row.parentNode;
  }

  table = row;
  while (table) {
    table = table.parentNode;

    if (table.nodeName.match (/^table$/i) && 
	list_contain (table, row)) /* target is a child table */ 
      break;
  }

  if (!table)
    return true;

  anchor = table.getAttribute ('anchor');
  rows = list_rows (table);

  if (e.ctrlKey) {
    list_row_toggle_selected (row);
  } else if (e.shiftKey) {
    if (anchor >= 0) {
      idx = list_row_index (rows, row);

      list_deselect_all (table, rows);

      if (idx < anchor) {
	for (i = idx; i <= anchor; i++) 
	  if (list_contain (table, rows[i]))
	    list_row_select (rows[i]);	
      } else {
	for (i = anchor; i <= idx; i++) 
	  if (list_contain (table, rows[i]))
	    list_row_select (rows[i]);
      }
    }
  } else {
    list_deselect_all (table, rows);
    list_row_toggle_selected (row);
    table.setAttribute ('anchor', list_row_index (rows, row));
  }


  return true;
}

function list_enable (id) {
  var table, rows, row, i;

  table = document.getElementById (id);
  rows = list_rows (table);
  for (i = 0; i < rows.length; i++) {
    row = rows[i];
    row.onmousedown = list_row_onmousedown;
  }
}

